apiVersion: cert-manager.io/v1
kind: ClusterIssuer
metadata:
  name: selfsigned-cluster-issuer
spec:
  selfSigned: {}
---
apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: ca-cert
spec:
  isCA: true
  duration: 8760h # 5 years
  commonName: default.svc.cluster.local
  secretName: root-ca-pair
  privateKey:
    algorithm: RSA
    encoding: PKCS8
    size: 4096
  issuerRef:
    name: selfsigned-cluster-issuer
    kind: ClusterIssuer
    group: cert-manager.io
---
apiVersion: cert-manager.io/v1
kind: ClusterIssuer
metadata:
  name: cluster-issuer-from-ca
spec:
  ca:
    secretName: root-ca-pair
---
apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: tls-for-mqtt
  namespace: default
spec:
  isCA: false
  duration: 2160h # 90d
  renewBefore: 360h # 15d
  commonName: mqtt-broker.default.svc
  dnsNames:
  - mqtt-broker.default.svc
  - mqtt.default.local
  secretName: tls-for-mqtt-key-pair
  privateKey:
    algorithm: RSA
    encoding: PKCS8
    size: 2048
  usages:
    - server auth
  issuerRef:
    name: cluster-issuer-from-ca
    kind: ClusterIssuer
    group: cert-manager.io